#include <string>
#include <vector>
#include <algorithm>
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
using namespace std;

#define FOR(i,p,k) for (int i=p; i<k; i++)
#define REP(i,n) for (int i=0; i<n; i++)

typedef signed long long LL;

/* OTOCZKA WYPUKLA */
FILE *IN;

#define PI 3.14159265358979323846

#define MAXN 101
int N; // Liczba budynkow
LL NN; // Liczba budynkow w long long, zeby nie konwertowac za kazdym razem
LL wys[MAXN]; // Tablica wysokosci budynkow
LL odl[MAXN]; // Tablica odleglosci budynkow
LL posl[MAXN]; // Tablica polozen lewych koncow budynkow
LL w; // Szerokosc budynku
LL h; // Wysokosc apartamentu

LL nap; // Numer apartamentu o ktory pytamy
int nbu; // Numer budynku o ktory pytamy
int ozn; // Oznaczenie apartamentu o ktory pytamy

int wczytaj_dane() {
  scanf("%d", &N);
  if (!N) return 0;
  scanf("%lld %lld", &w, &h);
  NN = (LL) N;
  posl[0] = 0LL;
  REP (i,N) {
    scanf("%lld", &(wys[i]));
    if (i < N-1) scanf ("%lld", &(odl[i]));
    posl[i+1] = posl[i] + odl[i] + w;
  }
  return 1;
}

int wczytaj_zapytanie() {
  scanf("%d", &ozn);
  if (!ozn) return 0;
  nbu = (ozn % 100) - 1;
  nap = (LL) (ozn / 100);
  return 1;
}

void wypisz_endl() {
  printf("\n\n");
}

void wypisz_napis(char *s) {
  printf("%s", s);
}

void wypisz_liczbe(int o) {
  printf("%d", o);
}

void wypisz_lewy_czas(double d) {
  int sec = (int) ((2 * atan(d) / PI) * 380 * 60);
  sec += 60 * (37 + 5 * 60);
  int s = sec % 60;
  int min = sec / 60;
  int m = min % 60;
  int h = min / 60;
  printf("%.2d:%.2d:%.2d", h,m,s);
}

void wypisz_prawy_czas(double d) {
  int sec = (int) (60.0 * (17.0 + 18.0 * 60.0) - (2 * atan(d) / PI) * 380 * 60);
  int s = sec % 60;
  int min = sec / 60;
  int m = min % 60;
  int h = min / 60;
  printf("%.2d:%.2d:%.2d", h,m,s);
}

int ol[MAXN][MAXN];
int sl[MAXN];
int op[MAXN][MAXN];
int sp[MAXN];

int kb(int po, int c) {
  int pb = ol[po][sl[po]-1];
  int ppb = ol[po][sl[po]-2];
  return ((wys[c]-wys[ppb]) * (posl[pb]-posl[ppb]) > (wys[pb]-wys[ppb]) * (posl[c]-posl[ppb]));
}

int kc(int po, int c) {
  int pb = op[po][sp[po]-1];
  int ppb = op[po][sp[po]-2];
  return ((wys[c]-wys[ppb]) * (posl[ppb]-posl[pb]) > (wys[pb]-wys[ppb]) * (posl[ppb]-posl[c]));
}

void tworz_otoczki() {
  REP (po,N) {
    sl[po] = 0;
    REP (c, po) {
      while (sl[po] > 1 && kb(po,c)) sl[po] -= 1;
      if (sl[po] == 1 && wys[ol[po][0]] <= wys[c]) sl[po] -= 1;
      ol[po][sl[po]] = c;
      sl[po] += 1;
    }
  }
  REP (po,N) {
    sp[po] = 0;
    for (int c = N - 1; c > po; c--) {
      while (sp[po] > 1 && kc(po,c)) sp[po] -= 1;
      if (sp[po] == 1 && wys[op[po][0]] <= wys[c]) sp[po] -= 1;
      op[po][sp[po]] = c;
      sp[po] += 1;
    }
  }
/*  REP (po, N) {
    printf("Otoczka lewa %d to ", po);
    REP (i, sl[po]) printf ("%d (%lld,%lld), ", ol[po][i], posl[ol[po][i]], wys[ol[po][i]]);
    printf("\n");
  }
  REP (po, N) {
    printf("Otoczka prawa %d to ", po);
    REP (i, sp[po]) printf ("%d (%lld,%lld), ", op[po][i], posl[op[po][i]], wys[op[po][i]]);
    printf("\n");
  }*/
}

int lewykat (int mid) { // Trafia za wysoko
  if (mid == 0) return 1;
  if (mid == sl[nbu]) return 0;
  int mb = ol[nbu][mid];
  int pb = ol[nbu][mid-1];
//  printf("Budynki w lewykat to mb: %d (%lld,%lld) i pb: %d (%lld,%lld)\n", mb, posl[mb],wys[mb], pb, posl[pb], wys[pb]);
//  printf("Lewykat dla mid %d, nbu %d, nap %lld: %lld * %lld = %lld ?> %lld = %lld * %lld\n", mid, nbu, nap, (LL)((LL) wys[mb]-(LL)wys[pb]), posl[nbu]-posl[pb]-w, (wys[mb]-wys[pb]) * (posl[nbu]-posl[pb]-w), (nap-wys[pb]-1LL) * (posl[mb]-posl[pb]), nap-wys[pb]-1LL, posl[mb]-posl[pb]);
  return ((wys[mb]-wys[pb]) * (posl[nbu]-posl[pb]-w) > (nap-wys[pb]-1LL) * (posl[mb]-posl[pb]));
}

int prawykat (int mid) { // Trafia za wysoko
  if (mid == 0) return 1;
  if (mid == sp[nbu]) return 0;
  int mb = op[nbu][mid];
  int pb = op[nbu][mid-1];
//  printf("Budynki w lewykat to mb: %d (%lld,%lld) i pb: %d (%lld,%lld)\n", mb, posl[mb],wys[mb], pb, posl[pb], wys[pb]);
//  printf("Lewykat dla mid %d, nbu %d, nap %lld: %lld * %lld = %lld ?> %lld = %lld * %lld\n", mid, nbu, nap, (LL)((LL) wys[mb]-(LL)wys[pb]), posl[nbu]-posl[pb]-w, (wys[mb]-wys[pb]) * (posl[nbu]-posl[pb]-w), (nap-wys[pb]-1LL) * (posl[mb]-posl[pb]), nap-wys[pb]-1LL, posl[mb]-posl[pb]);
  return ((wys[mb]-wys[pb]) * (posl[pb]-posl[nbu]-w) > (nap-wys[pb]-1LL) * (posl[pb]-posl[mb]));
}


int main ()
{
  IN = fopen ("sunlight.in", "r");
  int an = 0;
  while (wczytaj_dane()) {
    if (an) wypisz_endl();
    wypisz_napis("Apartment Complex: "); wypisz_liczbe(++an);
    tworz_otoczki();
    while (wczytaj_zapytanie()) {
      wypisz_endl(); wypisz_napis("Apartment "); wypisz_liczbe(ozn); wypisz_napis(": ");
      if (nbu < N && wys[nbu] >= nap) { // Czy apartament istnieje?
        double kle = 0.0;
        if (sl[nbu] > 0 && (nap <= wys[ol[nbu][0]])) { // Czy istnieje budynek na lewo i czy zaslania cokolwiek?
  	  int left = 0;
	  int right = sl[nbu];
	  while (left < right - 1) {
	    int mid = (left + right) / 2;
	    if (lewykat(mid)) left = mid; else right = mid;
	  }
//	  printf("Kat bierzemy od budynku %d o wsp %lld - %lld, %lld - %lld\n", right-1, posl[nbu], posl[ol[nbu][right-1]] + w, h * (nap - 1), h * wys[ol[nbu][right-1]]);
	  kle = ((double) (h * (wys[ol[nbu][right-1]] - nap + 1LL))) / ((double) (posl[nbu] - posl[ol[nbu][right-1]] - w));
	}
        wypisz_lewy_czas(kle); wypisz_napis(" - ");
        kle = 0.0;
        if (sp[nbu] > 0 && (nap <= wys[op[nbu][0]])) { // Czy istnieje budynek na lewo i czy zaslania cokolwiek?
  	  int left = 0;
	  int right = sp[nbu];
	  while (left < right - 1) {
	    int mid = (left + right) / 2;
	    if (prawykat(mid)) left = mid; else right = mid;
	  }
//	  printf("Kat bierzemy od budynku %d o wsp %lld - %lld, %lld - %lld\n", right-1, posl[nbu] + w, posl[op[nbu][right-1]], h * (nap - 1), h * wys[op[nbu][right-1]]);
	  kle = ((double) (h * (wys[op[nbu][right-1]] - nap + 1LL))) / ((double) (posl[op[nbu][right-1]] - w - posl[nbu]));
	}
	wypisz_prawy_czas(kle);
      } else {
        wypisz_napis("Does not exist");
      }
    } 
  }
  exit (0);
}
